var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { scan } from 'rxjs/operators';
import { BarActionType, } from '../types';
import { DEFAULT_COORDINATE_OFFSET, getNextSizeRelatedInfo } from './utils';
var DEFAULT_BAR_ACTION_SCAN_RESULT = {
    barID: -1,
    offset: 0,
    type: BarActionType.DEACTIVATE,
    originalCoordinate: DEFAULT_COORDINATE_OFFSET,
    defaultSizeInfoArray: [],
    sizeInfoArray: [],
    discard: true,
    flexGrowRatio: 0,
};
export function scanBarAction(config) {
    return scan(function (prevResult, action) {
        var result = {
            barID: action.barID,
            type: action.type,
        };
        switch (action.type) {
            case BarActionType.ACTIVATE:
                var _a = config.getSizeRelatedInfo(), sizeInfoArray = _a.sizeInfoArray, flexGrowRatio = _a.flexGrowRatio;
                return __assign({}, DEFAULT_BAR_ACTION_SCAN_RESULT, result, { originalCoordinate: action.coordinate, defaultSizeInfoArray: sizeInfoArray, sizeInfoArray: sizeInfoArray,
                    flexGrowRatio: flexGrowRatio });
            case BarActionType.MOVE:
                var offset = config.calculateOffset(action.coordinate, prevResult.originalCoordinate);
                return __assign({}, result, getNextSizeRelatedInfo(action.barID, offset, prevResult.defaultSizeInfoArray), { offset: offset, originalCoordinate: prevResult.originalCoordinate, defaultSizeInfoArray: prevResult.defaultSizeInfoArray, discard: false });
            case BarActionType.DEACTIVATE:
                return DEFAULT_BAR_ACTION_SCAN_RESULT;
        }
    }, DEFAULT_BAR_ACTION_SCAN_RESULT);
}
