import styled from '@emotion/styled';
import { ignoreProps } from '../utils';
const customStyledBarProps = [
    'context',
    'innerRef',
    'size',
    'onClick',
    'expandInteractiveArea',
    'onStatusChanged',
];
export const StyledBar = styled('div', {
    shouldForwardProp: ignoreProps(customStyledBarProps),
})(({ size = 10 }) => ({
    position: 'relative',
    flex: `0 0 ${size}px`,
}));
export const StyledInteractiveArea = styled.div(({ top = 0, right = 0, bottom = 0, left = 0, vertical }) => ({
    position: 'absolute',
    top: -top,
    left: -left,
    right: -right,
    bottom: -bottom,
    cursor: vertical ? 'row-resize' : 'col-resize',
    WebkitTapHighlightColor: 'transparent',
    userSelect: 'none',
}));
