import styled from '@emotion/styled';
import { ignoreProps } from '../utils';
const customProps = [
    'onSizeChanged',
    'size',
    'defaultSize',
    'maxSize',
    'minSize',
    'context',
    'disableResponsive',
    'innerRef',
    'flexGrow',
    'flexShrink',
    'flexBasis',
];
export const StyledSection = styled('div', {
    shouldForwardProp: ignoreProps(customProps),
})(({ context, maxSize, minSize, flexGrow, flexShrink, flexBasis }) => ({
    overflow: 'hidden',
    [context.vertical ? 'maxHeight' : 'maxWidth']: maxSize,
    [context.vertical ? 'minHeight' : 'minWidth']: minSize,
    flexGrow,
    flexShrink,
    flexBasis,
}));
