import * as React from 'react';
import resolve from 'rollup-plugin-node-resolve';
import commonjs from 'rollup-plugin-commonjs';

export default {
  context: 'this',

  external: ['react'],

  input: 'dist/esm/index.js',

  output: {
    file: 'dist/index.umd.js',
    format: 'umd',
    name: 'reactSimpleResizer',
    globals: { react: 'React' },
    sourcemap: true,
  },

  plugins: [
    resolve({
      extensions: ['.js'],
    }),

    commonjs({
      namedExports: {
        'node_modules/react/index.js': Object.keys(React),
      },
    }),
  ],
};
